<?php
/**
 *
 * Auther: heyu
 * DateTime: 2019-09-04 17:49
 *
 */

namespace kwy\tp5util;


use think\exception\PDOException;
use think\Model;

define('MULTI_MODEL_TYPE_DATETIME','datetime');
define('MULTI_MODEL_TYPE_CRC32','crc32');
define('MULTI_MODEL_TYPE_MOD','mod');
define('MULTI_MODEL_TYPE_DIY','diy');
define('MULTI_MODEL_MOD_DATETIME_YEAR',4);
define('MULTI_MODEL_MOD_DATETIME_MONTH',7);
define('MULTI_MODEL_MOD_DATETIME_DAY',10);

class MultiModel extends Model
{

    /**
     * 多字段分表 多个数组 每个数组内对字段声明分表参数，field分表字段 type => "datetime"|"mod"|"crc32" ,mod表示取余除数
     * @var array
     *
     * [
    'field'=>'pay_time',
    'type'=>'datetime',#datetime 是连续类型 支持区间查询
    'mod'=>4,#取值方式  4 年，
    ],
     * [
    'field'=>'pay_time',
    'type'=>'datetime',#datetime 是连续类型 支持区间查询
    'mod'=>4,#取值方式  4 年，
    ],
     */
    protected $multiConfig=[

    ];

    /**
     * 自动建表逻辑
     * @param $table_name
     * @throws \Exception
     * @return bool  当返回false时 系统不执行redo
     */
    protected function createTable($table_name){
        throw new \Exception('不支持自动创建分表:'.$table_name);
    }

    /**
     * @param array $data
     * @param bool $replace
     * @param bool $getLastInsID
     * @param null $sequence
     * @return int|string
     * @throws \Exception
     */
    public function insert(array $data = [], $replace = false, $getLastInsID = false, $sequence = null)
    {
        $this->where($data);
        $this->setQuery($this->db()->option('table',$this->getMultiTableName()));
        $result=$this->noTableRedo(function ()use($data,$replace,$getLastInsID,$sequence){
            $result=parent::insert($data, $replace, $getLastInsID, $sequence);
            return $result;
        });
        $this->setQuery(null);
        return $result;
    }

    public function group($group)
    {
        $this->setQuery($this->db());
        parent::group($group);
        return $this;
    }

    public function where($field, $op = null, $condition = null)
    {
        $this->setQuery($this->db());
        parent::where($field, $op, $condition);
        return $this;
    }

    /**
     * @param null $data
     * @param array $with
     * @param bool $cache
     * @return mixed
     * @throws \Exception
     */
    public function get($data = null, $with = [], $cache = false)
    {
        throw new \Exception('暂不支持主键查询，抽空改');
//        if ($this->getPk()!==$this->multiConfig['fields'][0]){
//            throw new \Exception('非主键分表不支持主键查询');#
//        }
//        $this->setQuery($this->db()->option('table',$this->getMultiTableName()));
//        $result=parent::get($data, $with, $cache);
//        $this->setQuery(null);
//        return $result;
    }


    public function order($field, $order = null)
    {
        $this->setQuery($this->db());
        parent::order($field, $order);
        return $this;
    }

    public function cache( $key = null,  $expire = null)
    {
        $this->setQuery($this->db());
        parent::cache($key, $expire);
        return $this;
    }

    public function lock($lock = false)
    {
        $this->setQuery($this->db());
        parent::lock($lock);
        return $this;
    }

    private function noTableRedo($callback){
        try{
            return call_user_func($callback);
        }catch (PDOException $e){
            $err_msg=$e->getMessage();
            $not_find='Base table or view not found';
            if (strpos($err_msg,$not_find)!==false){
                #TODO  建表
                $ret=$this->createTable($this->getMultiTableName());
                if ($ret!==false){
                    #redo
                    return call_user_func($callback);
                }
            }else{
                throw $e;
            }
        }
    }

    /**
     * 保存当前数据对象
     * @access public
     * @param  array  $data     数据
     * @param  array  $where    更新条件
     * @param  string $sequence 自增序列名
     * @return bool
     */
    public function save($data = [], $where = [], $sequence = null)
    {
        $this->setQuery($this->db()->option('table',$this->getMultiTableName()));
        $result=$this->noTableRedo(function()use($data,$where,$sequence){
            return parent::save($data,$where,$sequence);
        });
        $this->setQuery(null);
        return $result;
    }

    public function find($data = null)
    {
        $this->setQuery($this->db()->option('table',$this->getMultiTableName()));
        ## $result=parent::find($data);
        $result=$this->noTableRedo(function()use($data){
            return parent::find($data);
        });
        ##
        $this->setQuery(null);
        return $result;
    }

    public function paginate($listRows = null, $simple = false, $config = [])
    {
        $this->setQuery($this->db()->option('table',$this->getMultiTableName()));
        $result = $this->noTableRedo(function()use($listRows,$simple,$config){
            return parent::paginate($listRows, $simple, $config);
        });
        $this->setQuery(null);
        return $result;
    }

    public function select($data = null)
    {
        $this->setQuery($this->db()->option('table',$this->getMultiTableName()));
        $result=$this->noTableRedo(function()use($data){
            return parent::select($data);
        });
        $this->setQuery(null);
        return $result;
    }

    /**
     * @param $opts
     * @param $conf
     * @return string
     * @throws \Exception
     */
    private function cacSuffix($opts, $conf){
        $op='';
        $val='';
        if (empty($opts['where']['AND'])){
            $data=$this->getData();
            if (!empty($data)){
                $fieldList=[];
                foreach ($data as $k=>$v){
                    $fieldList[]=[$k,'=',$v];
                }
            }else{
                throw new \Exception('分表不允许全表查询');
            }
        }else{
            $fieldList=$opts['where']['AND'];
        }

        foreach ($fieldList as $v){
            if ($v[0]==$conf['field']){
                $op=$v[1];
                $val=$v[2];
            }
        }
        if (empty($op)){
            throw new \Exception('查询缺少字段'.$conf['field']);
        }
        if ($conf['type']=='datetime'){
            if (in_array($op,['between'])){
                if (is_string($val)&&strpos($val,',')){
                    $val=explode(',',$val);
                }
                if (!is_array($val)){
                    throw new \Exception('查询条件错误,不合法的查询值');
                }
                if (substr($val[0],0,$conf['mod'])!==substr($val[1],0,$conf['mod'])){
                    throw new \Exception('查询区间不能跨越'.substr($val[0],0,$conf['mod']));
                }
                $val=$val[0];
            }
            return '_'.str_replace('-','_',substr($val,0,$conf['mod']));
        }elseif($conf['type']=='mod'){
            if (in_array($op,['eq','='])){
                return '_'.($val%$conf['mod']);
            }else{
                throw new \Exception('该分表字段不允许'.$op.'查询');
            }
        }elseif ($conf['type']=='crc32'){
            return '_'.crc32($val)%$conf['mod'];
        }elseif ($conf['type']==MULTI_MODEL_TYPE_DIY){
            return $this->genSuffix($conf['field'],$op,$val);
        }else{
            throw new \Exception('暂不支持的分表方式:'.$conf['type']);
        }
    }

    /**
     * 子类实现
     * @param $field
     * @param $op
     * @param $val
     * @throws \Exception
     */
    protected function genSuffix($field,$op,$val){
        throw new \Exception('未实现分表后缀生成方法');
    }

    /**
     * @return string
     * @throws \Exception
     */
    protected function getMultiTableName(){
        $opts=$this->getOptions();
        $suffix='';
        foreach ($this->multiConfig as $v){
            $suffix.=$this->cacSuffix($opts,$v);
        }
        return $this->table.$suffix;
    }

    /**
     * @param mixed $field
     * @param bool $except
     * @return $this|\think\db\Query
     */
    public function field($field, bool $except = false)
    {
        $this->setQuery($this->db());
        parent::field($field, $except);
        return $this;
    }

    /**
     * @param array|string $field
     * @param string $value
     * @return int
     * @throws \Exception
     */
    public function setField($field, $value = '')
    {
        $this->setQuery($this->db()->option('table',$this->getMultiTableName()));
        $result = parent::setField($field, $value);
        $this->setQuery(null);
        return $result;
    }
}